﻿using System;
using System.Collections.Generic;
using System.Text;
 
namespace PoSHEditor
{
    public sealed class Singletons
    {
        private static ScriptEngine _theScriptEngine;

        /// <summary>
        /// Singleton to script engine
        /// </summary>
        public static ScriptEngine TheScriptEngine
        {
            get
            {
                if (_theScriptEngine == null)
                    _theScriptEngine = new ScriptEngine();

                return _theScriptEngine;
            }
        }

        public static void ReleaseScriptEngine()
        {
            _theScriptEngine = null;
        }
    }
}
